#include <iostream>
#include <fstream>
using namespace std;

class Magazin
{
private:
	char* denumire;
	const int cod;
	char** filiale;
	int nrFiliale;
	float *profituri;
	float cifraAfaceri;
	static int nrMagazine;

public:
	Magazin():cod(0)
	{
		denumire = new char[strlen("Kaufland")+1];
		strcpy(denumire, "Kaufland");
		nrFiliale = 1;
		filiale = new char*[nrFiliale];
		filiale[0] = new char[strlen("Colentina")+1];
		strcpy(filiale[0], "Colentina");
		profituri = new float[nrFiliale];
		profituri[0] = 0.0f;
		cifraAfaceri = 0.0f;
		nrMagazine++;
	}

	Magazin(char *d, int c, int nrf, char **fil, float *p, float ca):cod(c)
	{
		denumire = new char[strlen(d)+1];
		strcpy(denumire, d);
		nrFiliale = nrf;
		filiale = new char*[nrFiliale];
		for(int i=0;i<nrFiliale;i++)
		{
			filiale[i] = new char[strlen(fil[i])+1];
			strcpy(filiale[i], fil[i]);
		}
		profituri = new float[nrFiliale];
		for(int i=0;i<nrFiliale;i++)
			profituri[i] = p[i];
		cifraAfaceri = ca;
		nrMagazine++;
	}

	~Magazin()
	{
		delete[] denumire;
		for (int i=0;i<nrFiliale;i++)
			delete[] filiale[i];
		delete[] filiale;
		delete[] profituri;
		nrMagazine--;
	}

	void afisare();
	/*{
		cout<<"Magazinul "<<denumire<<" cu codul "<<cod<<" si cifra de afaceri "<<cifraAfaceri<<
			" are "<<nrFiliale<<" filiale"<<endl;
		cout<<"Lista de filiale: "<<endl;
		for(int i=0;i<nrFiliale;i++)
			cout<<filiale[i]<<" ";
		cout<<endl;
		cout<<"Profiturile pe filiale: "<<endl;
		for(int i=0;i<nrFiliale;i++)
			cout<<profituri[i]<<" ";
		cout<<endl;
	}*/

	friend ostream& operator<<(ostream& iesire, Magazin& m);
	friend ofstream& operator<<(ofstream& iesire, Magazin& m);
	
	friend istream& operator>>(istream& intrare, Magazin &m);
	/*{
		iesire<<"Magazinul "<<m.denumire<<" cu codul "<<m.cod<<" si cifra de afaceri "<<m.cifraAfaceri<<
			" are "<<m.nrFiliale<<" filiale"<<endl;
		iesire<<"Lista de filiale: "<<endl;
		for(int i=0;i<m.nrFiliale;i++)
			iesire<<m.filiale[i]<<" ";
		iesire<<endl;
		iesire<<"Profiturile pe filiale: "<<endl;
		for(int i=0;i<m.nrFiliale;i++)
			iesire<<m.profituri[i]<<" ";
		iesire<<endl;
		return iesire;
	}*/

	Magazin(Magazin &m):cod(m.cod)
	{
		denumire = new char[strlen(m.denumire)+1];
		strcpy(denumire, m.denumire);
		nrFiliale = m.nrFiliale;
		filiale = new char*[nrFiliale];
		for(int i=0;i<nrFiliale;i++)
		{
			filiale[i] = new char[strlen(m.filiale[i])+1];
			strcpy(filiale[i], m.filiale[i]);
		}
		profituri = new float[nrFiliale];
		for(int i=0;i<nrFiliale;i++)
			profituri[i] = m.profituri[i];
		cifraAfaceri = m.cifraAfaceri;
		nrMagazine++;
	}

	Magazin operator+(Magazin m)
	{
		Magazin temp = *this;
		char **aux = new char*[temp.nrFiliale+m.nrFiliale];
		for(int i=0;i<temp.nrFiliale;i++)
		{
			aux[i] = new char[strlen(temp.filiale[i])+1];
			strcpy(aux[i], temp.filiale[i]);
		}
		for(int j=0;j<m.nrFiliale;j++)
		{
			aux[temp.nrFiliale+j] = new char[strlen(m.filiale[j])+1];
			strcpy(aux[temp.nrFiliale+j], m.filiale[j]);
		}

		for (int i=0;i<temp.nrFiliale;i++)
			delete[] temp.filiale[i];
		delete[] temp.filiale;

		temp.nrFiliale += m.nrFiliale;
		temp.filiale = new char*[temp.nrFiliale];
		for(int i=0;i<temp.nrFiliale;i++)
		{
			temp.filiale[i] = new char[strlen(aux[i])+1];
			strcpy(temp.filiale[i], aux[i]);
		}

		for (int i=0;i<temp.nrFiliale;i++)
			delete[] aux[i];
		delete[] aux;

		return temp;
	}

	Magazin operator+(char *f)
	{
		Magazin temp = *this;
		char **aux = new char*[temp.nrFiliale+1];
		for(int i=0;i<temp.nrFiliale;i++)
		{
			aux[i] = new char[strlen(temp.filiale[i])+1];
			strcpy(aux[i], temp.filiale[i]);
		}
		
		aux[temp.nrFiliale] = new char[strlen(f)+1];
		strcpy(aux[temp.nrFiliale], f);
		

		for (int i=0;i<temp.nrFiliale;i++)
			delete[] temp.filiale[i];
		delete[] temp.filiale;

		temp.nrFiliale += 1;
		temp.filiale = new char*[temp.nrFiliale];
		for(int i=0;i<temp.nrFiliale;i++)
		{
			temp.filiale[i] = new char[strlen(aux[i])+1];
			strcpy(temp.filiale[i], aux[i]);
		}

		for (int i=0;i<temp.nrFiliale;i++)
			delete[] aux[i];
		delete[] aux;

		return temp;
	}

	friend Magazin operator+(char *f, Magazin &m)
	{
		
		char **aux = new char*[m.nrFiliale+1];
		for(int i=0;i<m.nrFiliale;i++)
		{
			aux[i] = new char[strlen(m.filiale[i])+1];
			strcpy(aux[i], m.filiale[i]);
		}
		
		aux[m.nrFiliale] = new char[strlen(f)+1];
		strcpy(aux[m.nrFiliale], f);
		

		for (int i=0;i<m.nrFiliale;i++)
			delete[] m.filiale[i];
		delete[] m.filiale;

		m.nrFiliale += 1;
		m.filiale = new char*[m.nrFiliale];
		for(int i=0;i<m.nrFiliale;i++)
		{
			m.filiale[i] = new char[strlen(aux[i])+1];
			strcpy(m.filiale[i], aux[i]);
		}

		for (int i=0;i<m.nrFiliale;i++)
			delete[] aux[i];
		delete[] aux;

		return m;
	}
};

int Magazin::nrMagazine = 0;

ostream& operator<<(ostream& iesire, Magazin& m)
	{
		iesire<<"Magazinul "<<m.denumire<<" cu codul "<<m.cod<<" si cifra de afaceri "<<m.cifraAfaceri<<
			" are "<<m.nrFiliale<<" filiale"<<endl;
		iesire<<"Lista de filiale: "<<endl;
		for(int i=0;i<m.nrFiliale;i++)
			iesire<<m.filiale[i]<<" ";
		iesire<<endl;
		iesire<<"Profiturile pe filiale: "<<endl;
		for(int i=0;i<m.nrFiliale;i++)
			iesire<<m.profituri[i]<<" ";
		iesire<<endl;
		return iesire;
	}

ofstream& operator<<(ofstream& iesire, Magazin& m)
	{
		iesire<<"Magazinul "<<m.denumire<<" cu codul "<<m.cod<<" si cifra de afaceri "<<m.cifraAfaceri<<
			" are "<<m.nrFiliale<<" filiale"<<endl;
		iesire<<"Lista de filiale: "<<endl;
		for(int i=0;i<m.nrFiliale;i++)
			iesire<<m.filiale[i]<<" ";
		iesire<<endl;
		iesire<<"Profiturile pe filiale: "<<endl;
		for(int i=0;i<m.nrFiliale;i++)
			iesire<<m.profituri[i]<<" ";
		iesire<<endl;
		return iesire;
	}

istream& operator>>(istream& intrare, Magazin &m)
{
	cout<<"Denumire: "<<endl;
	delete[] m.denumire;
	char buffer[20];
	intrare>>buffer;
	m.denumire = new char[strlen(buffer)+1];
	strcpy(m.denumire, buffer);
	return intrare;
}

void Magazin::afisare()
	{
		cout<<"Magazinul "<<denumire<<" cu codul "<<cod<<" si cifra de afaceri "<<cifraAfaceri<<
			" are "<<nrFiliale<<" filiale"<<endl;
		cout<<"Lista de filiale: "<<endl;
		for(int i=0;i<nrFiliale;i++)
			cout<<filiale[i]<<" ";
		cout<<endl;
		cout<<"Profiturile pe filiale: "<<endl;
		for(int i=0;i<nrFiliale;i++)
			cout<<profituri[i]<<" ";
		cout<<endl;
	}

void main()
{
	Magazin m1;
	char *filiale[3] = {"Lujerului","Colentina","Mosilor"};
	float profituri[3] = {12000, 11370, 14500};
	Magazin m2("Cora", 123, 3, filiale, profituri, 120000);

	//m1.afisare();
	//m2.afisare();

	cout<<m1;
	cout<<m2;

	ofstream fisier("iesire.txt",ios_base::out);
	fisier<<m1<<m2;
	fisier.close();

	cout<<m2+m1;
	(m1+m2).afisare();
	Magazin m3 = m1+m2;

	cout<<m1+"Obor";

	cout<<"Obor"+m2;
}